package com.devaux.PointInterpolationApp;
 
import java.util.Objects;
import java.lang.Math; 

public class PointInterpolation {

    final double THRESHOLD = .0001;

    private final double x;
    private final double y;
    private double interpolation;


    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public double getInterpolation() {
        return interpolation;
    }

    
    public void setInterpolation(double interpolation) {
       this.interpolation = interpolation;
    }

    public PointInterpolation(double x, double y, double interpolation) {
        this.x = x;
        this.y = y;
        this.interpolation = interpolation;
    }

    public double distanceTo(double x, double y){

        return Math.sqrt( (x - this.x) * (x - this.x)  + (y - this.y) * (y - this.y) );
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        PointInterpolation that = (PointInterpolation) o;
        final double absX = Math.abs(that.x - x);
        final double absY = Math.abs(that.y - y);
        return absX < THRESHOLD && absY < THRESHOLD;
    }

    @Override
    public int hashCode() {
        return Objects.hash(x, y);
    }
}
