package com.devaux.PointInterpolationApp;

import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import java.util.List;

@RestController
public class PointInterpolationController {

    @CrossOrigin
    @GetMapping("/interpolation")
    public PointInterpolation interpolation(@RequestParam(value = "x", defaultValue = "0") String xStr,
                                       @RequestParam(value = "y", defaultValue = "0") String yStr,
                                       @RequestParam(value = "d", defaultValue = "0.01") String dStr) {
        return MappingDataProvider.getInstance().getInterpolation(Double.parseDouble(xStr), Double.parseDouble(yStr), Double.parseDouble(dStr));
    }

    @CrossOrigin
    @GetMapping("/nearestneighbours")
    public List<PointInterpolation> nearestneighbours(@RequestParam(value = "x", defaultValue = "0") String xStr,
                                       @RequestParam(value = "y", defaultValue = "0") String yStr,
                                       @RequestParam(value = "d", defaultValue = "0.01") String dStr) {
        return MappingDataProvider.getInstance().getNearestNeighbours(Double.parseDouble(xStr), Double.parseDouble(yStr), Double.parseDouble(dStr));
    }
}
